/*
  CPP_CONTEST=2013Cal-2012
  CPP_PROBLEM=B
  CPP_LANG=C+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=marte 2 mercurio 2
*/

/* RECORD
Tomás Ramírez García, Víctor Manuel Ruiz Sánchez 
students of the University of Murcia, Spain
In the II Spanish Parallel Programming Contest, Elche, Spain
September 19, 2012
time 894 msec
speed-up 18.19
*/ 

/*RECORD in the new system
when the programs in the record table are run in the new system
formed by marte+mercurio (two hexacores),
it is the absolute record, with
time 2357 msec
speed-up 8.23
*/

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>
#include <mpi.h>
#include <math.h>
#include <string.h>

 
int unadistancia(int t,int *a,int numero)
{
	int i,j,cont=0;
	int d=0,dist,dc;
	int *filas,*columnas;

	filas=(int *) malloc(sizeof(int)*t*t);
	columnas=(int *) malloc(sizeof(int)*t*t);

	for(i=0;i<t;i++)
	{
		for(j=0;j<t;j++)
		{
			if(a[i*t+j]==numero)
			{
				filas[cont]=i;
				columnas[cont]=j;
				cont++;
			}
		}
	}
	
	for(i=0;i<cont;i++)
	{
		for(j=i+1;j<cont;j++)
		{	
			dist=filas[j]-filas[i];
			dc=columnas[i]-columnas[j];
			if(dc>0)
				dist+=dc;
			else
				dist-=dc;
			if(dist>d)
				d=dist;
		}
	}

	free(filas);
	free(columnas);

	return d;	 
}
		
void sec(int t,int *a,int n,int *numeros,int *distancias,int nodo,int np)
{
	int i, my_n, *my_numeros, *my_distancias;
	int * _distancias;
	int * _numeros;

    MPI_Bcast(&t,1,MPI_INT,0,MPI_COMM_WORLD);
    MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD);

//	printf("BC de t y n (%s:%d)\n", __FILE__,__LINE__);
//	fflush(stdout);

	my_n = ceil(((double)n) / ((double)np));

	if (nodo == 0) {
		
		_numeros = (int *) malloc(sizeof(int)*my_n*np);
		_distancias=(int *) malloc(sizeof(int)*my_n*np);
	
		memcpy(_numeros, numeros, n*sizeof(int));
		memcpy(_distancias, distancias, n*sizeof(int));

		
	/*
		realloc(numeros, sizeof(int)*my_n*np);
		realloc(distancias, sizeof(int)*my_n*np);
	*/
	} else {
		a = NULL;
		a = (int *) malloc(sizeof(int)*t*t);
	}

//	printf("Alloc a y locales numeros/distancias (%s:%d)\n", __FILE__,__LINE__);
//	fflush(stdout);
	
	my_numeros = (int *) malloc(sizeof(int)*my_n);
	my_distancias=(int *) malloc(sizeof(int)*my_n);

    MPI_Bcast(a,t*t,MPI_INT,0,MPI_COMM_WORLD);
	MPI_Scatter(_numeros, my_n, MPI_INT, my_numeros, my_n, MPI_INT, 0, MPI_COMM_WORLD);

//	printf("BC a y scatter de numeros (%s:%d)\n", __FILE__,__LINE__);
//	fflush(stdout);
	
	omp_set_num_threads(3);
	#pragma omp parallel for private(i) shared(a,t,numeros)
	for(i=0; i < my_n; i++)
		my_distancias[i]=unadistancia(t,a,my_numeros[i]); 

//	printf("Fuera de OMP (%s:%d)\n", __FILE__,__LINE__);
//	fflush(stdout);
	
	MPI_Gather(my_distancias, my_n, MPI_INT, _distancias, my_n, MPI_INT, 0, MPI_COMM_WORLD);

//	printf("Gather distancias (%s:%d)\n", __FILE__,__LINE__);
//	fflush(stdout);
/*
	if (nodo == 0) {
		omp_set_num_threads(8);
		#pragma omp parallel for private(i) shared(a,t,numeros)
		for(i=(np-1)*my_n; i < n; i++)
			distancias[i]=unadistancia(t,a,numeros[i]); 
	}
*/
	if (nodo != 0 && a != NULL)
		free(a);
	
//	printf("a liberado (%s:%d)\n", __FILE__,__LINE__);
//	fflush(stdout);
	if (my_numeros != NULL)
		free(my_numeros);
		
//	printf("my_num liberado (%s:%d)\n", __FILE__,__LINE__);
//	fflush(stdout);
		
	if (my_distancias != NULL)
		free(my_distancias);
//	printf("my_dist liberado (%s:%d)\n", __FILE__,__LINE__);
//	fflush(stdout);


	if (nodo == 0) {
		
		memcpy(numeros, _numeros, n*sizeof(int));
		memcpy(distancias, _distancias, n*sizeof(int));

		free(_numeros);
		free(_distancias);
	/*
		realloc(numeros, sizeof(int)*my_n*np);
		realloc(distancias, sizeof(int)*my_n*np);
	*/
	}
}
